﻿@page "/subsystem-compartment-list"
@inject HttpClient HttpClient

<PageTitle Title="サブシステム区分一覧" />

<MudTable Items="_systemCompartments" Loading="_isLoading" Hover="true" Striped="true" Dense="true" FixedHeader="true" Height="550px"
          Filter="new Func<SubSystemCompartmentEntity,bool>(FilterFunc1)" Class="mt-2">
    <ToolBarContent>
        <MudTextField @bind-Value="_searchString" Placeholder="検索したい文字列を入力しエンター" Adornment="Adornment.Start" AdornmentIcon="@Icons.Material.Filled.Search" IconSize="Size.Medium" Class="mt-0"></MudTextField>
        <MudSpacer />
        <MudTooltip Text="新規追加">
            <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Add" Size="Size.Small" Link="@($"/subsystem-compartment-detail/{nameof(PageMode.Create)}")" />
        </MudTooltip>
    </ToolBarContent>
    <HeaderContent>
        <MudTh>
            <MudTableSortLabel InitialDirection="SortDirection.Ascending" SortBy="new Func<SubSystemCompartmentEntity, object>(x =>x.SystemCompartment.Compartment)">
                @systemCompartmentForLabel.SystemCompartment.GetDisplayName(s => s.Compartment)
            </MudTableSortLabel>
        </MudTh>
        <MudTh>@systemCompartmentForLabel.SystemCompartment.GetDisplayName(s => s.CompartmentName)</MudTh>
        <MudTh>
            <MudTableSortLabel SortBy="new Func<SubSystemCompartmentEntity, object>(x =>x.Compartment)">
                @systemCompartmentForLabel.GetDisplayName(s => s.Compartment)
            </MudTableSortLabel>
        </MudTh>
        <MudTh>@systemCompartmentForLabel.GetDisplayName(s => s.CompartmentName)</MudTh>
        <MudTh>@systemCompartmentForLabel.GetDisplayName(s => s.Description)</MudTh>
        <MudTh>@systemCompartmentForLabel.GetDisplayName(s => s.Remarks)</MudTh>
        <MudTh>操作</MudTh>
    </HeaderContent>
    <RowTemplate>
        <MudTd>@context.SystemCompartment.Compartment</MudTd>
        <MudTd>@context.SystemCompartment.CompartmentName</MudTd>
        <MudTd>@context.Compartment</MudTd>
        <MudTd>@context.CompartmentName</MudTd>
        <MudTd>@context.Description</MudTd>
        <MudTd>@context.Remarks</MudTd>
        <MudTd>
            <MudTooltip Text="照会">
                <MudFab Icon="@Icons.Material.Filled.ListAlt" Size="Size.Small" Link="@($"/subsystem-compartment-detail/{nameof(PageMode.Show)}/{context.Id}")"></MudFab>
            </MudTooltip>
            <MudTooltip Text="編集">
                <MudFab Icon="@Icons.Material.Filled.Edit" Size="Size.Small" Link="@($"/subsystem-compartment-detail/{nameof(PageMode.Edit)}/{context.Id}")"></MudFab>
            </MudTooltip>
            <MudTooltip Text="削除">
                <MudFab Icon="@Icons.Material.Filled.Delete" Size="Size.Small" Link="@($"/subsystem-compartment-detail/{nameof(PageMode.Delete)}/{context.Id}")"></MudFab>
            </MudTooltip>
        </MudTd>
    </RowTemplate>
    <PagerContent>
        <MudTablePager RowsPerPageString="1ページ当りの表示件数" InfoFormat="{all_items}件中 {first_item}～{last_item} 件表示" />
    </PagerContent>
</MudTable>

@code {
    private string _searchString = "";
    private bool _isLoading = false;
    private IEnumerable<SubSystemCompartmentEntity> _systemCompartments = new List<SubSystemCompartmentEntity>();
    private SubSystemCompartmentEntity systemCompartmentForLabel = new();

    protected async override Task OnInitializedAsync()
    {
        _isLoading = true;
        _systemCompartments = await HttpClient.GetFromJsonAsync<List<SubSystemCompartmentEntity>>("api/SubSystemCompartments");
        _isLoading = false;
    }

    private bool FilterFunc1(SubSystemCompartmentEntity systemCompartment) => FilterFunc(systemCompartment, _searchString);

    private bool FilterFunc(SubSystemCompartmentEntity systemCompartment, string searchString)
    {
        if (string.IsNullOrWhiteSpace(searchString))
            return true;
        if (systemCompartment.SystemCompartment.Compartment.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (systemCompartment.SystemCompartment.CompartmentName.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (systemCompartment.Compartment.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (systemCompartment.CompartmentName.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (systemCompartment.Description != null && systemCompartment.Description.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        return false;
    }
}